C*************************************************************
C     PRCALC : MAIN CALCULATION                              *
C*************************************************************
C
      SUBROUTINE PRCALC(NDATA,NENRG,NPARM,X,Y,Z,V,P1,X0,E0,D)
      INCLUDE 'param.f'
      REAL*8 X(NX),Y(NX),Z(NX),V(MX),E0(NP),D(NX,NP)
      REAL*8 P1(NP),X0(MP)
      REAL*8 W(NP,NX)
      REAL*8 X1,X2,X3,X4
      INTEGER NDATA,NENRG,NPARM
      INTEGER I,J,K,L,IJ,JK,KL,ISTART,JSTART,KSTART
C
C***************************************
C     Y <= Y - D P0                    *
C***************************************
      DO 10 I=1,NDATA
         X1=0.0
         DO 15 K=1,NPARM
            X1=X1+D(I,K)*P1(K)
   15    CONTINUE
CD       write(6,*) I,Y(I),X1,Y(I)-X1
         Z(I)=Y(I)-X1
   10 CONTINUE
C***************************************
C     W <= D * X0                      *
C***************************************
      DO 30 I=1,NDATA
         JSTART=0
         DO 30 J=1,NPARM
            X1=0.0
            DO 31 K=1,J
               JK=JSTART+K
   31          X1=X1+X0(JK)*D(I,K)
            JSTART=JSTART+J
            JK=JSTART
            DO 32 K=J+1,NPARM
               JK=JK+K-1
   32          X1=X1+X0(JK)*D(I,K)
            W(J,I)=X1
   30 CONTINUE
C***************************************
C     V <= ( D * X0 * D**T + V )**(-1) *
C***************************************
      ISTART=0
      DO 40 I=1,NDATA
         DO 41 J=1,I
            X1=0.0
            IJ=ISTART+J
            DO 42 K=1,NPARM
   42          X1=X1+W(K,J)*D(I,K)
            V(IJ)=V(IJ)+X1
   41    CONTINUE
         ISTART=ISTART+I
   40 CONTINUE
      CALL INVMTX(NDATA,V)
C***************************************
C     CALC P1,X1                       *
C***************************************
      ISTART=0
      DO 50 I=1,NPARM
C        write(0,*) I
         DO 51 J=1,I-1
            X1=0.0
            IJ=ISTART+J
            KSTART=0
            DO 52 K=1,NDATA
               X3=0.0
               DO 53 L=1,K
                  KL=KSTART+L
                  X3=X3+V(KL)*W(J,L)
   53          CONTINUE
               KSTART=KSTART+K
               KL=KSTART
               DO 54 L=K+1,NDATA
                  KL=KL+L-1
                  X3=X3+V(KL)*W(J,L)
   54          CONTINUE
               X1=X1+W(I,K)*X3
   52       CONTINUE
            X0(IJ)=X0(IJ)-X1
   51    CONTINUE
         ISTART=ISTART+I
         X1=0.0
         X2=0.0
         IJ=ISTART
         KSTART=0
         DO 55 K=1,NDATA
            X3=0.0
            X4=0.0
            DO 56 L=1,K
               KL=KSTART+L
               X3=X3+V(KL)*W(I,L)
               X4=X4+V(KL)*Z(L)
   56       CONTINUE
            KSTART=KSTART+K
            KL    =KSTART
            DO 57 L=K+1,NDATA
               KL=KL+L-1
               X3=X3+V(KL)*W(I,L)
               X4=X4+V(KL)*Z(L)
   57       CONTINUE
            X1=X1+W(I,K)*X3
            X2=X2+W(I,K)*X4
   55    CONTINUE
         X0(IJ)=X0(IJ)-X1
         P1(I) =P1(I) +X2
   50 CONTINUE
      RETURN
      END
