C*************************************************************
C     CHISQR : CHI SQUARE                                    *
C*************************************************************
C
      SUBROUTINE CHISQR(NDATA,NPARM,Y,Z,V,P1,D,CHISQ)
      INCLUDE 'param.f'
      REAL*8 Y(NX),Z(NX),V(MX),D(NX,NP)
      REAL*8 P1(NP)
      REAL*8 CHISQ,X1,X2
      INTEGER NDATA,NPARM
      INTEGER I,J,K,IJ,ISTART
C
      DO 10 I=1,NDATA
         X1=0.0
         DO 15 K=1,NPARM
            X1=X1+D(I,K)*P1(K)
   15    CONTINUE
ca       Z(I)=Y(I)-X1
         Z(I)=1.0-EXP(X1)/EXP(Y(I))
   10 CONTINUE
      ISTART=0
      X2=0.0
      DO 60 I=1,NDATA
         X1=0.0
         DO 61 J=1,I-1
            IJ=ISTART+J
   61       X1=X1+V(IJ)*Z(J)
         ISTART=ISTART+I
         X2    =X2+Z(I)*X1
   60 CONTINUE
      X1=0.0
      DO 62 I=1,NDATA
         IJ=I*(I+1)/2
         X1=X1+V(IJ)*Z(I)**2
   62 CONTINUE
      CHISQ =2.0*X2+X1
      RETURN
      END
