C*************************************************************
C     GETPRM : READ PRIOR PARAMETERS                         *
C*************************************************************
C
      SUBROUTINE GETPRM(KC,NPARM,NKIND,NENRG,E0,P0,P1,PE,X0,PNAME,INDEX)
      INCLUDE 'param.f'
      REAL*8 E0(NP),P0(NP),P1(NP),PE(NP),X0(MP),X
      INTEGER KC,NPARM,NKIND,NENRG(NR),INDEX(NR)
      INTEGER I,J,K,L,N,ISTART,KUNIT
      CHARACTER*12 PNAME(NR),DUMMY
C
      I=1
      J=0
      IF(KC.EQ.0) THEN
         KUNIT=50
      ELSE
         KUNIT=KC
      ENDIF
   10 READ(KUNIT  ,2000,END=20) PNAME(I),NENRG(I)
      READ(KUNIT  ,2010)       (E0(J+K),P0(J+K),K=1,NENRG(I))
      READ(KUNIT+1,2020)        DUMMY
      READ(KUNIT+1,2010)       (X      ,PE(J+K),K=1,NENRG(I))
CD    WRITE(6,2000)        PNAME(I),NENRG(I)
CD    WRITE(6,2010)       (E0(J+K),P0(J+K),PE(J+K),K=1,NENRG(I))
      DO 30 K=1,NENRG(I)
         P0(J+K)=LOG(P0(J+K))
   30 CONTINUE
      J=J+NENRG(I)
      I=I+1
      GO TO 10
   20 CONTINUE
      NKIND=I-1
      NPARM=J
C
      INDEX(1)=0
      DO 40 J=2,NKIND
   40    INDEX(J)=INDEX(J-1)+NENRG(J-1)
C
C***************************************
C     QUICK SORT                       *
C***************************************
      DO 50 N=1,NKIND
        DO 50 J=1,NENRG(N)
           L=J
           DO 60 I=J,NENRG(N)
              IF(E0(INDEX(N)+I).LT.E0(INDEX(N)+L)) L=I
   60      CONTINUE
           CALL SWAP(E0(INDEX(N)+J),E0(INDEX(N)+L))
           CALL SWAP(P0(INDEX(N)+J),P0(INDEX(N)+L))
           CALL SWAP(PE(INDEX(N)+J),PE(INDEX(N)+L))
   50 CONTINUE
C
      DO 70 I=1,NPARM
         P1(I)=P0(I)
         ISTART=I*(I-1)/2
         DO 70 J=1,I
            IF(J.EQ.I) THEN
               X=PE(I)*PE(I)
            ELSE
               X=0.0
            END IF
            X0(ISTART+J)=X
   70 CONTINUE
 2000 FORMAT(A12,31X,I5)
 2010 FORMAT(6E11.4)
 2020 FORMAT(A12)
      RETURN
      END
C
